// Java class srp.Srp is a proxy for talking to a Go program.
//   gobind -lang=java go-srp
//
// File is generated by gobind. Do not edit.
package srp;

import go.Seq;

public abstract class Srp {
	static {
		Seq.touch(); // for loading the native library
		_init();
	}
	
	private Srp() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	
	
	/**
	 * ErrDataAfterModulus found extra data after decode the modulus
	 */
	public static native void setErrDataAfterModulus(java.lang.Exception v);
	/**
	 * ErrDataAfterModulus found extra data after decode the modulus
	 */
	public static native java.lang.Exception getErrDataAfterModulus();
	
	/**
	 * ErrInvalidSignature invalid modulus signature
	 */
	public static native void setErrInvalidSignature(java.lang.Exception v);
	/**
	 * ErrInvalidSignature invalid modulus signature
	 */
	public static native java.lang.Exception getErrInvalidSignature();
	
	// skipped variable RandReader with unsupported type: io.Reader
	
	public static native String getModulusKey();
	/**
	 * HashPassword returns the hash of password argument. Based on version number
	following arguments are used in addition to password:
	* 0, 1, 2: userName and modulus
	* 3, 4: salt and modulus
	 */
	public static native byte[] hashPassword(long authVersion, String password, String userName, byte[] salt, byte[] modulus) throws Exception;
	/**
	 * MailboxPassword get mailbox password hash
	
	Parameters:
		 - password string: a mailbox password
		 - salt []byte: a salt is random 128 bits data
	Returns:
	  - hashed string: a hashed password
	  - err error: throw error
	 */
	public static native String mailboxPassword(String password, byte[] salt) throws Exception;
	/**
	 * NewAuth Creates new Auth from strings input. Salt and server ephemeral are in
	base64 format. Modulus is base64 with signature attached. The signature is
	verified against server key. The version controls password hash algorithm.
	
	Parameters:
		 - version int: The *x* component of the vector.
		 - username string: The *y* component of the vector.
		 - password string: The *z* component of the vector.
		 - salt string:
	Returns:
	  - auth *Auth: the pre caculated auth information
	  - err error: throw error
	Usage:
	
	Warnings:
		 - Be carefull! Poos can hurt.
	 */
	public static native Auth newAuth(long version, String username, String password, String salt, String signedModulus, String serverEphemeral) throws Exception;
	/**
	 * NewAuthForVerifier Creates new Auth from strings input. Salt and server ephemeral are in
	base64 format. Modulus is base64 with signature attached. The signature is
	verified against server key. The version controls password hash algorithm.
	
	Parameters:
		 - version int: The *x* component of the vector.
		 - username string: The *y* component of the vector.
		 - password string: The *z* component of the vector.
		 - salt string:
	Returns:
	  - auth *Auth: the pre caculated auth information
	  - err error: throw error
	Usage:
	
	Warnings:
		 - none.
	 */
	public static native Auth newAuthForVerifier(String password, String signedModulus, byte[] rawSalt) throws Exception;
	public static native byte[] randomBits(long bits) throws Exception;
	public static native byte[] randomBytes(long byes) throws Exception;
	/**
	 * VersionNumber get current libaray version
	 */
	public static native String versionNumber();
}
